﻿#!/usr/bin/python
# -*- coding: utf-8 -*-

import  sqlite3, os
from DebugLog import getScriptPath, DebugLog
   
class DbBus:
   def __init__(self):
      DebugLog("DbBus::__init__")
      datas = os.path.join(os.path.dirname(getScriptPath()), 'datas/bus.sqlite')
      
      if not os.path.exists(datas):
         raise RuntimeError("'%s' not found"%datas)

      conn = sqlite3.connect(datas)
      self.c = conn.cursor()

   def execute(self, req):
      self.c.execute(req)
      return self.c
      
class DbTrain:
   def __init__(self):
      datas = os.path.join(os.path.dirname(getScriptPath()), 'datas/tec.sqlite')
      
      if not os.path.exists(datas):
         raise RuntimeError("'%s' not found"%datas)

      conn = sqlite3.connect(datas)
      self.c = conn.cursor()

   def execute(self, req):
      self.c.execute(req)
      return self.c

class GareManager:
   def __init__(self, db):
      self.db = db

   def code(self, gareName):
      if not gareName:
         raise Exception("Nom de gare vide")

      code = ''
      c = self.db.execute('SELECT gares.rowid, name, code, ligne FROM gares,lignes WHERE name="%s" AND gares.rowid=lignes.gareid'%gareName)
      fe = c.fetchone()
      if fe:
         code = fe[2]
      else:
         raise Exception('Gare "%s" non trouvée'%gareName)
      return code

   def name(self, gareCode):
      if not gareCode:
         raise Exception("Code gare vide")

      name = ''
      c = self.db.execute('SELECT gares.name FROM gares,lignes WHERE code="%s" AND gares.rowid=lignes.gareid'%gareCode)
      fe = c.fetchone()
      if fe:
         name = fe[0]
      else:
         raise Exception('Gare "%s" non trouvée'%gareCode)
      return name

